/*
 * 2D Physic Engine
 * main.cpp: App entry point
 * Based on pikuma.com Learn Game Physics Engine Programming course.
 * Copyright (c) 2022 986-Studio. All Right Reserved
 *
 * Created by Manoël Trapier on 06/06/2022.
 */

#include <logger.h>
#include <app.h>

int main(int argc, char *argv[])
{
    application app;
    logger::info("Booting up Physic Engine version %s", VERSION);

    app.parseParameters(argc, argv);
    app.setup();

    logger::info("Ready to go!");

    while(app.isRunning())
    {
        app.input();
        app.update();
        app.render();
    }

    app.destroy();

    return 0;
}
